Index: trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diaptr.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 2528)
@@ -503,71 +355,87 @@
       !! ** Purpose :   Initialization, namelist read
       !!----------------------------------------------------------------------
-      INTEGER ::   inum       ! temporary logical unit
+      INTEGER ::   jn           ! dummy loop indices 
+      INTEGER ::   inum, ierr   ! local integers
 #if defined key_mpp_mpi
       INTEGER, DIMENSION(1) :: iglo, iloc, iabsf, iabsl, ihals, ihale, idid
 #endif
       !!
-      NAMELIST/namptr/ ln_diaptr, ln_diaznl, ln_subbas, ln_ptrcomp, nf_ptr, nf_ptr_wri
-      !!----------------------------------------------------------------------
-
-      REWIND ( numnam )              ! Read Namelist namptr : poleward transport parameters
-      READ   ( numnam, namptr )
-
-      IF(lwp) THEN                   ! Control print
+      NAMELIST/namptr/ ln_diaptr, ln_diaznl, ln_subbas, ln_ptrcomp, nn_fptr, nn_fwri
+      !!----------------------------------------------------------------------
+
+      REWIND( numnam )                 ! Read Namelist namptr : poleward transport parameters
+      READ  ( numnam, namptr )
+
+      IF(lwp) THEN                     ! Control print
          WRITE(numout,*)
          WRITE(numout,*) 'dia_ptr_init : poleward transport and msf initialization'
          WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist namptr : set ptr parameters'
-         WRITE(numout,*) '      Switch for ptr diagnostic (T) or not (F)  ln_diaptr  = ', ln_diaptr
-         WRITE(numout,*) '      Atl/Pac/Ind basins computation            ln_subbas  = ', ln_subbas
-         WRITE(numout,*) '      Frequency of computation                  nf_ptr     = ', nf_ptr
-         WRITE(numout,*) '      Frequency of outputs                      nf_ptr_wri = ', nf_ptr_wri
+         WRITE(numout,*) '      Poleward heat & salt transport (T) or not (F)      ln_diaptr  = ', ln_diaptr
+         WRITE(numout,*) '      Overturning heat & salt transport                  ln_ptrcomp = ', ln_ptrcomp
+         WRITE(numout,*) '      T & S zonal mean and meridional stream function    ln_diaznl  = ', ln_diaznl 
+         WRITE(numout,*) '      Global (F) or glo/Atl/Pac/Ind/Indo-Pac basins      ln_subbas  = ', ln_subbas
+         WRITE(numout,*) '      Frequency of computation                           nn_fptr    = ', nn_fptr
+         WRITE(numout,*) '      Frequency of outputs                               nn_fwri    = ', nn_fwri
       ENDIF
 
-      IF( .NOT. ln_diaptr )   RETURN
-      
-      IF( lk_mpp )   CALL mpp_ini_znl      ! Define MPI communicator for zonal sum
-
-      IF( ln_subbas ) THEN                 ! load sub-basin mask
-         CALL iom_open( 'subbasins', inum )
-         CALL iom_get( inum, jpdom_data, 'atlmsk', abasin )      ! Atlantic basin
-         CALL iom_get( inum, jpdom_data, 'pacmsk', pbasin )      ! Pacific basin
-         CALL iom_get( inum, jpdom_data, 'indmsk', ibasin )      ! Indian basin
-         CALL iom_close( inum )
-         dbasin(:,:) = MAX ( pbasin(:,:), ibasin(:,:) )
-         sbasin(:,:) = tmask (:,:,1)
-         WHERE ( gphit (:,:) < -30.e0) sbasin(:,:) = 0.e0
+      IF( ln_subbas ) THEN   ;   nptr = 5       ! Global, Atlantic, Pacific, Indian, Indo-Pacific
+      ELSE                   ;   nptr = 1       ! Global only
+      ENDIF
+
+      rc_pwatt = rc_pwatt * rau0 * rcp          ! conversion from K.s-1 to PetaWatt
+
+      IF( .NOT. ln_diaptr ) THEN       ! diaptr not used
+        RETURN
+      ELSE                             ! Allocate the diaptr arrays
+         ALLOCATE( btmsk(jpi,jpj,nptr) ,                                                                      &
+            &      htr_adv(jpj) , str_adv(jpj) , htr_ldf(jpj) , str_ldf(jpj) , htr_ove(jpj) , str_ove(jpj),   &
+            &      htr(jpj,nptr) , str(jpj,nptr) ,                                                              &
+            &      tn_jk(jpj,jpk,nptr) , sn_jk (jpj,jpk,nptr) , v_msf(jpj,jpk,nptr) ,                         &
+            &      sjk  (jpj,jpk,nptr) , r1_sjk(jpj,jpk,nptr)                       , STAT=ierr  )
+         !
+         IF( ierr > 0 ) THEN
+            CALL ctl_stop( 'dia_ptr_init : unable to allocate standard arrays' )   ;   RETURN
+         ENDIF
+#if defined key_diaeiv
+!!       IF( lk_diaeiv )   &              ! eddy induced velocity arrays
+            ALLOCATE( htr_eiv(jpj,nptr) , str_eiv(jpj,nptr) , v_msf_eiv(jpj,jpk,nptr) , STAT=ierr )
+         !
+         IF( ierr > 0 ) THEN
+            CALL ctl_stop( 'dia_ptr_init : unable to allocate eiv arrays' )   ;   RETURN
+         ENDIF
+#endif
       ENDIF
       
-!!gm CAUTION : this is only valid in fixed volume case !
-
-      ! inverse of the ocean "zonal" v-point section
-      surf_jk_glo(:,:) = ptr_tjk( tmask(:,:,:) )
-      surf_jk_r_glo(:,:) = 0.e0
-      WHERE( surf_jk_glo(:,:) /= 0.e0 )   surf_jk_r_glo(:,:) = 1.e0 / surf_jk_glo(:,:)
+      IF( lk_mpp )   CALL mpp_ini_znl     ! Define MPI communicator for zonal sum
+
+      IF( ln_subbas ) THEN                ! load sub-basin mask
+         CALL iom_open( 'subbasins', inum )
+         CALL iom_get( inum, jpdom_data, 'atlmsk', btmsk(:,:,2) )   ! Atlantic basin
+         CALL iom_get( inum, jpdom_data, 'pacmsk', btmsk(:,:,3) )   ! Pacific  basin
+         CALL iom_get( inum, jpdom_data, 'indmsk', btmsk(:,:,4) )   ! Indian   basin
+         CALL iom_close( inum )
+         btmsk(:,:,5) = MAX ( btmsk(:,:,3), btmsk(:,:,4) )          ! Indo-Pacific basin
+         WHERE( gphit(:,:) < -30._wp)   ;   btm30(:,:) = 0._wp      ! mask out Southern Ocean
+         ELSE WHERE                     ;   btm30(:,:) = tmask(:,:,1)
+         END WHERE
+      ENDIF
+      btmsk(:,:,1) = tmask_i(:,:)                                   ! global ocean
       
-      IF (ln_subbas) THEN
-         surf_jk_atl(:,:) = ptr_tjk( tmask (:,:,:), abasin(:,:) )
-         surf_jk_r_atl(:,:) = 0.e0
-         WHERE( surf_jk_atl(:,:) /= 0.e0 )   surf_jk_r_atl(:,:) = 1.e0 / surf_jk_atl(:,:)
-         !
-         surf_jk_pac(:,:) = ptr_tjk( tmask (:,:,:), pbasin(:,:) )
-         surf_jk_r_pac(:,:) = 0.e0
-         WHERE( surf_jk_pac(:,:) /= 0.e0 )   surf_jk_r_pac(:,:) = 1.e0 / surf_jk_pac(:,:)
-         ! 
-         surf_jk_ind(:,:) = ptr_tjk( tmask (:,:,:), ibasin(:,:) )
-         surf_jk_r_ind(:,:) = 0.e0
-         WHERE( surf_jk_ind(:,:) /= 0.e0 )   surf_jk_r_ind(:,:) = 1.e0 / surf_jk_ind(:,:)
-         !
-         surf_jk_ipc(:,:) = ptr_tjk( tmask (:,:,:), dbasin(:,:) )
-         surf_jk_r_ipc(:,:) = 0.e0
-         WHERE( surf_jk_ipc(:,:) /= 0.e0 )   surf_jk_r_ipc(:,:) = 1.e0 / surf_jk_ipc(:,:)
-      END IF
-
+      DO jn = 1, nptr
+         btmsk(:,:,jn) = btmsk(:,:,jn) * tmask_i(:,:)               ! interior domain only
+      END DO
       
-      !!----------------------------------------------------------------------
+      IF( lk_vvl )   CALL ctl_stop( 'diaptr: error in vvl case as constant i-mean surface is used' )
+
+      !                                   ! i-sum of e1v*e3v surface and its inverse
+      DO jn = 1, nptr
+         sjk(:,:,jn) = ptr_tjk( tmask(:,:,:), btmsk(:,:,jn) )
+         r1_sjk(:,:,jn) = 0._wp
+         WHERE( sjk(:,:,jn) /= 0._wp )   r1_sjk(:,:,jn) = 1._wp / sjk(:,:,jn)
+      END DO
 
 #if defined key_mpp_mpi 
-      iglo (1) = jpjglo
+      iglo (1) = jpjglo                   ! MPP case using MPI  ('key_mpp_mpi')
       iloc (1) = nlcj
       iabsf(1) = njmppt(narea)
@@ -576,14 +444,5 @@
       ihale(1) = nlcj - nlej
       idid (1) = 2
-
-!-$$      IF(lwp) THEN
-!-$$          WRITE(numout,*)
-!-$$          WRITE(numout,*) 'dia_ptr_init :   iloc  = ', iloc 
-!-$$          WRITE(numout,*) '~~~~~~~~~~~~     iabsf = ', iabsf
-!-$$          WRITE(numout,*) '                 ihals = ', ihals
-!-$$          WRITE(numout,*) '                 ihale = ', ihale
-!-$$      ENDIF 
-
-      CALL flio_dom_set ( jpnj, nproc/jpni, idid, iglo, iloc, iabsf, iabsl, ihals, ihale, 'BOX', nidom_ptr)
+      CALL flio_dom_set( jpnj, nproc/jpni, idid, iglo, iloc, iabsf, iabsl, ihals, ihale, 'BOX', nidom_ptr )
 #else
       nidom_ptr = FLIO_DOM_NONE
@@ -610,5 +469,5 @@
       INTEGER, SAVE, DIMENSION (jpj*jpk) ::         ndex_atl_30  , ndex_pac_30  , ndex_ind_30  , ndex_ipc_30
       INTEGER, SAVE, DIMENSION (jpj)     :: ndex_h, ndex_h_atl_30, ndex_h_pac_30, ndex_h_ind_30, ndex_h_ipc_30
-
+      !!
       CHARACTER (len=40)       ::   clhstnam, clop, clop_once, cl_comment   ! temporary names
       INTEGER                  ::   iline, it, itmod, ji, jj, jk            !
@@ -622,34 +481,25 @@
 
       ! define time axis
-      it    = kt / nf_ptr
+      it    = kt / nn_fptr
       itmod = kt - nit000 + 1
       
-!-$$      IF(lwp) THEN
-!-$$         WRITE(numout,*)
-!-$$         WRITE(numout,*) 'dia_ptr_wri : kt = ', kt, 'it = ', it, ' itmod = ', itmod, ' niter = ', niter
-!-$$         WRITE(numout,*) '~~~~~~~~~~~~'
-!-$$      ENDIF
-
       ! Initialization
       ! --------------
       IF( kt == nit000 ) THEN
-
-         niter = (nit000 - 1) / nf_ptr
-
-!-$$         IF(lwp) THEN
-!-$$            WRITE(numout,*)
-!-$$            WRITE(numout,*) 'dia_ptr_wri : poleward transport and msf writing: initialization , niter = ', niter
-!-$$            WRITE(numout,*) '~~~~~~~~~~~~'
-!-$$         ENDIF
-
+         niter = ( nit000 - 1 ) / nn_fptr
          zdt = rdt
          IF( nacc == 1 )   zdt = rdtmin
-
-         ! Reference latitude
+         !
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'dia_ptr_wri : poleward transport and msf writing: initialization , niter = ', niter
+            WRITE(numout,*) '~~~~~~~~~~~~'
+         ENDIF
+
+         ! Reference latitude (used in plots)
          ! ------------------
          !                                           ! =======================
          IF( cp_cfg == "orca" ) THEN                 !   ORCA configurations
             !                                        ! =======================
-
             IF( jp_cfg == 05  )   iline = 192   ! i-line that passes near the North Pole
             IF( jp_cfg == 025 )   iline = 384   ! i-line that passes near the North Pole
@@ -657,5 +507,5 @@
             IF( jp_cfg == 2   )   iline =  48   ! i-line that passes near the North Pole
             IF( jp_cfg == 4   )   iline =  24   ! i-line that passes near the North Pole
-            zphi(:) = 0.e0
+            zphi(:) = 0._wp
             DO ji = mi0(iline), mi1(iline) 
                zphi(:) = gphiv(ji,:)         ! if iline is in the local domain
@@ -663,14 +513,14 @@
                IF( jp_cfg == 05 ) THEN
                   DO jj = mj0(jpjdta), mj1(jpjdta) 
-                     zphi( jj ) = zphi(mj0(jpjdta-1)) + (zphi(mj0(jpjdta-1))-zphi(mj0(jpjdta-2)))/2.
-                     zphi( jj ) = MIN( zphi(jj), 90.)
+                     zphi( jj ) = zphi(mj0(jpjdta-1)) + ( zphi(mj0(jpjdta-1))-zphi(mj0(jpjdta-2)) ) * 0.5_wp
+                     zphi( jj ) = MIN( zphi(jj), 90._wp )
                   END DO
                END IF
                IF( jp_cfg == 1 .OR. jp_cfg == 2 .OR. jp_cfg == 4 ) THEN
                   DO jj = mj0(jpjdta-1), mj1(jpjdta-1) 
-                     zphi( jj ) = 88.5e0
+                     zphi( jj ) = 88.5_wp
                   END DO
                   DO jj = mj0(jpjdta  ), mj1(jpjdta  ) 
-                     zphi( jj ) = 89.5e0
+                     zphi( jj ) = 89.5_wp
                   END DO
                END IF
@@ -680,5 +530,4 @@
             CALL mpp_sum( zphi, jpj, ncomm_znl )        
 #endif
-
             !                                        ! =======================
          ELSE                                        !   OTHER configurations 
@@ -690,5 +539,5 @@
          ! Work only on westmost processor (will not work if mppini2 is used)
 #if defined key_mpp_mpi
-         IF ( l_znl_root ) THEN 
+         IF( l_znl_root ) THEN 
 #endif
             !
@@ -696,5 +545,5 @@
             ! ----------------
             ! Define frequency of output and means
-            zsto = nf_ptr * zdt
+            zsto = nn_fptr * zdt
             IF( ln_mskland )   THEN    ! put 1.e+20 on land (very expensive!!)
                clop      = "ave(only(x))"
@@ -705,6 +554,6 @@
             ENDIF
 
-            zout = nf_ptr_wri * zdt
-            zfoo(:) = 0.e0
+            zout = nn_fwri * zdt
+            zfoo(:) = 0._wp
 
             ! Compute julian date from starting date of the run
@@ -716,5 +565,5 @@
             ! Requested by IPSL people, use by their postpro...
             IF(lwp) THEN
-               CALL dia_nam( clhstnam, nf_ptr_wri,' ' )
+               CALL dia_nam( clhstnam, nn_fwri,' ' )
                CALL ctl_opn( inum, 'date.file', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, lwp, narea )
                WRITE(inum,*) clhstnam
@@ -723,45 +572,43 @@
 #endif
 
-            CALL dia_nam( clhstnam, nf_ptr_wri, 'diaptr' )
+            CALL dia_nam( clhstnam, nn_fwri, 'diaptr' )
             IF(lwp)WRITE( numout,*)" Name of diaptr NETCDF file : ", clhstnam
 
             ! Horizontal grid : zphi()
             CALL histbeg(clhstnam, 1, zfoo, jpj, zphi,   &
-               1, 1, 1, jpj, niter, zjulian, zdt*nf_ptr, nhoridz, numptr, domain_id=nidom_ptr)
+               1, 1, 1, jpj, niter, zjulian, zdt*nn_fptr, nhoridz, numptr, domain_id=nidom_ptr)
             ! Vertical grids : gdept_0, gdepw_0
             CALL histvert( numptr, "deptht", "Vertical T levels",   &
-               "m", jpk, gdept_0, ndepidzt, "down" )
+               &                   "m", jpk, gdept_0, ndepidzt, "down" )
             CALL histvert( numptr, "depthw", "Vertical W levels",   &
-               "m", jpk, gdepw_0, ndepidzw, "down" )
+               &                   "m", jpk, gdepw_0, ndepidzw, "down" )
 
             !
-            CALL wheneq ( jpj*jpk, MIN(surf_jk_glo(:,:), 1.e0), 1, 1., ndex  , ndim  )      ! Lat-Depth
-            CALL wheneq ( jpj    , MIN(surf_jk_glo(:,1), 1.e0), 1, 1., ndex_h, ndim_h )     ! Lat
-
-            IF (ln_subbas) THEN
-               z_1 (:,1) = 1.0e0
-               WHERE ( gphit (jpi/2,:) .LT. -30 ) z_1 (:,1) = 0.e0
+            CALL wheneq ( jpj*jpk, MIN(sjk(:,:,1), 1._wp), 1, 1., ndex  , ndim  )      ! Lat-Depth
+            CALL wheneq ( jpj    , MIN(sjk(:,1,1), 1._wp), 1, 1., ndex_h, ndim_h )     ! Lat
+
+            IF( ln_subbas ) THEN
+               z_1(:,1) = 1._wp
+               WHERE ( gphit(jpi/2,:) < -30._wp )   z_1(:,1) = 0._wp
                DO jk = 2, jpk
-                  z_1 (:,jk) = z_1 (:,1)
+                  z_1(:,jk) = z_1(:,1)
                END DO
-
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_atl(:,:)         , 1.e0), 1, 1., ndex_atl     , ndim_atl      ) ! Lat-Depth
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_atl(:,:)*z_1(:,:), 1.e0), 1, 1., ndex_atl_30  , ndim_atl_30   ) ! Lat-Depth
-               CALL wheneq ( jpj    , MIN(surf_jk_atl(:,1)*z_1(:,1), 1.e0), 1, 1., ndex_h_atl_30, ndim_h_atl_30 ) ! Lat
-
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_pac(:,:)         , 1.e0), 1, 1., ndex_pac     , ndim_pac      ) ! Lat-Depth
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_pac(:,:)*z_1(:,:), 1.e0), 1, 1., ndex_pac_30  , ndim_pac_30   ) ! Lat-Depth
-               CALL wheneq ( jpj    , MIN(surf_jk_pac(:,1)*z_1(:,1), 1.e0), 1, 1., ndex_h_pac_30, ndim_h_pac_30 ) ! Lat
-
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_ind(:,:)         , 1.e0), 1, 1., ndex_ind     , ndim_ind      ) ! Lat-Depth
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_ind(:,:)*z_1(:,:), 1.e0), 1, 1., ndex_ind_30  , ndim_ind_30   ) ! Lat-Depth
-               CALL wheneq ( jpj    , MIN(surf_jk_ind(:,1)*z_1(:,1), 1.e0), 1, 1., ndex_h_ind_30, ndim_h_ind_30 ) ! Lat
-
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_ipc(:,:)         , 1.e0), 1, 1., ndex_ipc     , ndim_ipc      ) ! Lat-Depth
-               CALL wheneq ( jpj*jpk, MIN(surf_jk_ipc(:,:)*z_1(:,:), 1.e0), 1, 1., ndex_ipc_30  , ndim_ipc_30   ) ! Lat-Depth
-               CALL wheneq ( jpj    , MIN(surf_jk_ipc(:,1)*z_1(:,1), 1.e0), 1, 1., ndex_h_ipc_30, ndim_h_ipc_30 ) ! Lat
-
+               !                       ! Atlantic (jn=2)
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,2)         , 1._wp), 1, 1., ndex_atl     , ndim_atl      ) ! Lat-Depth
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,2)*z_1(:,:), 1._wp), 1, 1., ndex_atl_30  , ndim_atl_30   ) ! Lat-Depth
+               CALL wheneq ( jpj    , MIN(sjk(:,1,2)*z_1(:,1), 1._wp), 1, 1., ndex_h_atl_30, ndim_h_atl_30 ) ! Lat
+               !                       ! Pacific (jn=3)
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,3)         , 1._wp), 1, 1., ndex_pac     , ndim_pac      ) ! Lat-Depth
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,3)*z_1(:,:), 1._wp), 1, 1., ndex_pac_30  , ndim_pac_30   ) ! Lat-Depth
+               CALL wheneq ( jpj    , MIN(sjk(:,1,3)*z_1(:,1), 1._wp), 1, 1., ndex_h_pac_30, ndim_h_pac_30 ) ! Lat
+               !                       ! Indian (jn=4)
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,4)         , 1._wp), 1, 1., ndex_ind     , ndim_ind      ) ! Lat-Depth
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,4)*z_1(:,:), 1._wp), 1, 1., ndex_ind_30  , ndim_ind_30   ) ! Lat-Depth
+               CALL wheneq ( jpj    , MIN(sjk(:,1,4)*z_1(:,1), 1._wp), 1, 1., ndex_h_ind_30, ndim_h_ind_30 ) ! Lat
+               !                       ! Indo-Pacific (jn=5)
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,5)         , 1._wp), 1, 1., ndex_ipc     , ndim_ipc      ) ! Lat-Depth
+               CALL wheneq ( jpj*jpk, MIN(sjk(:,:,5)*z_1(:,:), 1._wp), 1, 1., ndex_ipc_30  , ndim_ipc_30   ) ! Lat-Depth
+               CALL wheneq ( jpj    , MIN(sjk(:,1,5)*z_1(:,1), 1._wp), 1, 1., ndex_h_ipc_30, ndim_h_ipc_30 ) ! Lat
             ENDIF
-
             ! 
 #if defined key_diaeiv
@@ -772,5 +619,5 @@
             !  Zonal mean T and S
 
-            IF ( ln_diaznl ) THEN 
+            IF( ln_diaznl ) THEN 
                CALL histdef( numptr, "zotemglo", "Zonal Mean Temperature","C" ,   &
                   1, jpj, nhoridz, jpk, 1, jpk, ndepidzt, 32, clop, zsto, zout )
@@ -888,76 +735,67 @@
 
 #if defined key_mpp_mpi
-      IF( MOD( itmod, nf_ptr ) == 0 .AND. l_znl_root ) THEN
+      IF( MOD( itmod, nn_fptr ) == 0 .AND. l_znl_root ) THEN
 #else
-      IF( MOD( itmod, nf_ptr ) == 0  ) THEN
+      IF( MOD( itmod, nn_fptr ) == 0  ) THEN
 #endif
          niter = niter + 1
 
-!-$$         IF(lwp) THEN
-!-$$            WRITE(numout,*)
-!-$$            WRITE(numout,*) 'dia_ptr_wri : write Poleward Transports at time-step : kt = ', kt, &
-!-$$               & 'it = ', it, ' itmod = ', itmod, ' niter = ', niter
-!-$$            WRITE(numout,*) '~~~~~~~~~~'
-!-$$            WRITE(numout,*)
-!-$$         ENDIF
-
-         IF (ln_diaznl ) THEN 
-            CALL histwrite( numptr, "zosrfglo", niter, surf_jk_glo , ndim, ndex )
-            CALL histwrite( numptr, "zotemglo", niter, tn_jk_glo  , ndim, ndex )
-            CALL histwrite( numptr, "zosalglo", niter, sn_jk_glo  , ndim, ndex )
+         IF( ln_diaznl ) THEN 
+            CALL histwrite( numptr, "zosrfglo", niter, sjk  (:,:,1) , ndim, ndex )
+            CALL histwrite( numptr, "zotemglo", niter, tn_jk(:,:,1)  , ndim, ndex )
+            CALL histwrite( numptr, "zosalglo", niter, sn_jk(:,:,1)  , ndim, ndex )
 
             IF (ln_subbas) THEN 
-               CALL histwrite( numptr, "zosrfatl", niter, surf_jk_atl, ndim_atl, ndex_atl )
-               CALL histwrite( numptr, "zosrfpac", niter, surf_jk_pac, ndim_pac, ndex_pac )
-               CALL histwrite( numptr, "zosrfind", niter, surf_jk_ind, ndim_ind, ndex_ind )
-               CALL histwrite( numptr, "zosrfipc", niter, surf_jk_ipc, ndim_ipc, ndex_ipc )
-
-               CALL histwrite( numptr, "zotematl", niter, tn_jk_atl  , ndim_atl, ndex_atl )
-               CALL histwrite( numptr, "zosalatl", niter, sn_jk_atl  , ndim_atl, ndex_atl )
-               CALL histwrite( numptr, "zotempac", niter, tn_jk_pac  , ndim_pac, ndex_pac )
-               CALL histwrite( numptr, "zosalpac", niter, sn_jk_pac  , ndim_pac, ndex_pac )
-               CALL histwrite( numptr, "zotemind", niter, tn_jk_ind  , ndim_ind, ndex_ind )
-               CALL histwrite( numptr, "zosalind", niter, sn_jk_ind  , ndim_ind, ndex_ind )
-               CALL histwrite( numptr, "zotemipc", niter, tn_jk_ipc  , ndim_ipc, ndex_ipc )
-               CALL histwrite( numptr, "zosalipc", niter, sn_jk_ipc  , ndim_ipc, ndex_ipc )
+               CALL histwrite( numptr, "zosrfatl", niter, sjk(:,:,2), ndim_atl, ndex_atl )
+               CALL histwrite( numptr, "zosrfpac", niter, sjk(:,:,3), ndim_pac, ndex_pac )
+               CALL histwrite( numptr, "zosrfind", niter, sjk(:,:,4), ndim_ind, ndex_ind )
+               CALL histwrite( numptr, "zosrfipc", niter, sjk(:,:,5), ndim_ipc, ndex_ipc )
+
+               CALL histwrite( numptr, "zotematl", niter, tn_jk(:,:,2)  , ndim_atl, ndex_atl )
+               CALL histwrite( numptr, "zosalatl", niter, sn_jk(:,:,2)  , ndim_atl, ndex_atl )
+               CALL histwrite( numptr, "zotempac", niter, tn_jk(:,:,3)  , ndim_pac, ndex_pac )
+               CALL histwrite( numptr, "zosalpac", niter, sn_jk(:,:,3)  , ndim_pac, ndex_pac )
+               CALL histwrite( numptr, "zotemind", niter, tn_jk(:,:,4)  , ndim_ind, ndex_ind )
+               CALL histwrite( numptr, "zosalind", niter, sn_jk(:,:,4)  , ndim_ind, ndex_ind )
+               CALL histwrite( numptr, "zotemipc", niter, tn_jk(:,:,5)  , ndim_ipc, ndex_ipc )
+               CALL histwrite( numptr, "zosalipc", niter, sn_jk(:,:,5)  , ndim_ipc, ndex_ipc )
             END IF
          ENDIF
 
          ! overturning outputs:
-         CALL histwrite( numptr, "zomsfglo", niter, v_msf_glo, ndim, ndex )
+         CALL histwrite( numptr, "zomsfglo", niter, v_msf(:,:,1), ndim, ndex )
          IF( ln_subbas .AND. ln_diaznl ) THEN
-            CALL histwrite( numptr, "zomsfatl", niter, v_msf_atl , ndim_atl_30, ndex_atl_30 )
-            CALL histwrite( numptr, "zomsfpac", niter, v_msf_pac , ndim_pac_30, ndex_pac_30 )
-            CALL histwrite( numptr, "zomsfind", niter, v_msf_ind , ndim_ind_30, ndex_ind_30 )
-            CALL histwrite( numptr, "zomsfipc", niter, v_msf_ipc , ndim_ipc_30, ndex_ipc_30 )
+            CALL histwrite( numptr, "zomsfatl", niter, v_msf(:,:,2) , ndim_atl_30, ndex_atl_30 )
+            CALL histwrite( numptr, "zomsfpac", niter, v_msf(:,:,3) , ndim_pac_30, ndex_pac_30 )
+            CALL histwrite( numptr, "zomsfind", niter, v_msf(:,:,4) , ndim_ind_30, ndex_ind_30 )
+            CALL histwrite( numptr, "zomsfipc", niter, v_msf(:,:,5) , ndim_ipc_30, ndex_ipc_30 )
          ENDIF
 #if defined key_diaeiv
-         CALL histwrite( numptr, "zomsfeiv", niter, v_msf_eiv_glo, ndim  , ndex   )
-#endif
-
+         CALL histwrite( numptr, "zomsfeiv", niter, v_msf_eiv(:,:,1), ndim  , ndex   )
+#endif
 
          ! heat transport outputs:
          IF( ln_subbas ) THEN
-            CALL histwrite( numptr, "sohtatl", niter, ht_atl  , ndim_h_atl_30, ndex_h_atl_30 )
-            CALL histwrite( numptr, "sohtpac", niter, ht_pac  , ndim_h_pac_30, ndex_h_pac_30 )
-            CALL histwrite( numptr, "sohtind", niter, ht_ind  , ndim_h_ind_30, ndex_h_ind_30 )
-            CALL histwrite( numptr, "sohtipc", niter, ht_ipc  , ndim_h_ipc_30, ndex_h_ipc_30 )
-            CALL histwrite( numptr, "sostatl", niter, st_atl  , ndim_h_atl_30, ndex_h_atl_30 )
-            CALL histwrite( numptr, "sostpac", niter, st_pac  , ndim_h_pac_30, ndex_h_pac_30 )
-            CALL histwrite( numptr, "sostind", niter, st_ind  , ndim_h_ind_30, ndex_h_ind_30 )
-            CALL histwrite( numptr, "sostipc", niter, st_ipc  , ndim_h_ipc_30, ndex_h_ipc_30 )
+            CALL histwrite( numptr, "sohtatl", niter, htr(:,2)  , ndim_h_atl_30, ndex_h_atl_30 )
+            CALL histwrite( numptr, "sohtpac", niter, htr(:,3)  , ndim_h_pac_30, ndex_h_pac_30 )
+            CALL histwrite( numptr, "sohtind", niter, htr(:,4)  , ndim_h_ind_30, ndex_h_ind_30 )
+            CALL histwrite( numptr, "sohtipc", niter, htr(:,5)  , ndim_h_ipc_30, ndex_h_ipc_30 )
+            CALL histwrite( numptr, "sostatl", niter, str(:,2)  , ndim_h_atl_30, ndex_h_atl_30 )
+            CALL histwrite( numptr, "sostpac", niter, str(:,3)  , ndim_h_pac_30, ndex_h_pac_30 )
+            CALL histwrite( numptr, "sostind", niter, str(:,4)  , ndim_h_ind_30, ndex_h_ind_30 )
+            CALL histwrite( numptr, "sostipc", niter, str(:,5)  , ndim_h_ipc_30, ndex_h_ipc_30 )
          ENDIF
 
-         CALL histwrite( numptr, "sophtadv", niter, pht_adv     , ndim_h, ndex_h )
-         CALL histwrite( numptr, "sophtldf", niter, pht_ldf     , ndim_h, ndex_h )
-         CALL histwrite( numptr, "sopstadv", niter, pst_adv     , ndim_h, ndex_h )
-         CALL histwrite( numptr, "sopstldf", niter, pst_ldf     , ndim_h, ndex_h )
-         IF ( ln_ptrcomp ) THEN 
-            CALL histwrite( numptr, "sopstove", niter, pst_ove_glo , ndim_h, ndex_h )
-            CALL histwrite( numptr, "sophtove", niter, pht_ove_glo , ndim_h, ndex_h )
+         CALL histwrite( numptr, "sophtadv", niter, htr_adv     , ndim_h, ndex_h )
+         CALL histwrite( numptr, "sophtldf", niter, htr_ldf     , ndim_h, ndex_h )
+         CALL histwrite( numptr, "sopstadv", niter, str_adv     , ndim_h, ndex_h )
+         CALL histwrite( numptr, "sopstldf", niter, str_ldf     , ndim_h, ndex_h )
+         IF( ln_ptrcomp ) THEN 
+            CALL histwrite( numptr, "sopstove", niter, str_ove(:) , ndim_h, ndex_h )
+            CALL histwrite( numptr, "sophtove", niter, htr_ove(:) , ndim_h, ndex_h )
          ENDIF
 #if defined key_diaeiv
-         CALL histwrite( numptr, "sophteiv", niter, pht_eiv_glo  , ndim_h, ndex_h )
-         CALL histwrite( numptr, "sopsteiv", niter, pst_eiv_glo  , ndim_h, ndex_h )
+         CALL histwrite( numptr, "sophteiv", niter, htr_eiv(:,1)  , ndim_h, ndex_h )
+         CALL histwrite( numptr, "sopsteiv", niter, str_eiv(:,1)  , ndim_h, ndex_h )
 #endif
          !
